#include "sndserv.h"
#include <cstdio>
#include <cstdlib>

#ifdef G_OS_WIN32

#else
	#include <esd.h>
#endif

static gpointer play_file_mix(gpointer data)
{
#ifdef G_OS_WIN32

#else
	esd_play_file ("reciteword", (gchar *)data, 1);
#endif
	return NULL;
}

/*
static void play_file_after_pre(gpointer data,gpointer user_data)
{
#ifdef G_OS_WIN32

#else
	esd_play_file ("reciteword", (gchar *)user_data, 1);
#endif
	return NULL;
}

class CThreadPool
{
	GThreadPool *pool;
public:
	CThreadPool();
	~CThreadPool();
};

CThreadPool::CThreadPool()
{
	pool = g_thread_pool_new(play_file_after_pre,NULL,1,FALSE,NULL);
}

CThreadPool::~CThreadPool()
{
	g_thread_pool_free(pool,);
}
*/


void play_file(const char *filename,PLAY_METHOD method)
{
#ifdef G_OS_WIN32

#else
	//esd_play_file ("reciteword", filename, 1);  //it can't return quickly :( when in typing,press wrong key will cause freezing.
		
	// the system() function is inefficiency, should change to use thread to call esd_play_file().
	/*gchar command[256];
	sprintf(command,"esdplay %s &",filename);
	system(command);*/
	switch (method)
	{
		case PM_MIX:
		{
			GThread * thread;
			thread = g_thread_create(play_file_mix,(gpointer)filename,false,NULL);  //use GThreadPool may be more efficient.
			break;
		}
		case PM_STOP_PRE:   // it is hard to done,may need write my own esd_play_file.
		{
			break;
		}
		case PM_AFTER_PRE:  // use GThreadPool can do this,but,it does seems very useful before PM_STOP_PRE is done.
		{
			//GThreadPool *threadpool;
			
			break;
		}
	}
	
	
#endif

}
